using Yao.EasyBuild, Yao, SymEngine

function sym_variational_circuit(nbit, nlayer; entangler = cnot)
    circuit = chain(nbit)
    k = 0
    genθ() = (k += 1; Basic(Symbol(:θ, k)))

    ent = chain(nbit, entangler(nbit, i, mod1(i+1, nbit)) for i in 1:nbit)
    has_param = nparameters(ent) != 0
    for i in 1:(nlayer+1)
        i != 1 && push!(circuit, has_param ? deepcopy(ent) : ent)
        r = chain(nbit)
        for j in 1:nbit
            ci =
                i == 1 ? (i == nlayer + 1 ? Rx(genθ()) : chain(Rx(genθ()), Rz(genθ()))) :
                (
                    i == nlayer + 1 ? chain(Rz(genθ()), Rx(genθ())) :
                    chain(Rz(genθ()), Rx(genθ()), Rz(genθ()))
                )
            push!(r, put(nbit, j => ci))
        end
        push!(circuit, r)
    end
    circuit
end

circ = sym_variational_circuit(2, 1)

reg = arrayreg(Basic, bit"00") => circ
op = put(2, 2 => Z)
ex = expect'(op, reg)[2]
params = randn(nparameters(circ))
assign = Dict(zip(parameters(circ), params))
ex2 = map(x -> ComplexF64(subs(x, assign...)), ex)
circ2 = variational_circuit(2, 1)
dispatch!(circ2, params)
real(ex2) ≈ real(expect'(op, ArrayReg(bit"00") => circ2)[2])

parametric_mat(::Type{T}, ::Val{:Rx}, theta::Basic) where {T} =
    Basic[cos(theta / 2) -im*sin(theta / 2); -im*sin(theta / 2) cos(theta / 2)]
parametric_mat(::Type{T}, ::Val{:Ry}, theta::Basic) where {T} =
    Basic[cos(theta / 2) -sin(theta / 2); sin(theta / 2) cos(theta / 2)]
parametric_mat(::Type{T}, ::Val{:Rz}, theta::Basic) where {T} =
    Diagonal(Basic[exp(-im * theta / 2), exp(im * theta / 2)])
parametric_mat(::Type{T}, ::Val{:CPHASE}, theta::Basic) where {T} = Diagonal(Basic[1, 1, 1, exp(im * theta)])
parametric_mat(::Type{T}, ::Val{:PSWAP}, theta::Basic) where {T} = parametric_mat(Basic, Const.SWAP, theta)

for G in [:Rx, :Ry, :Rz, :CPHASE]
    # forward single gates
    @eval function YaoArrayRegister.instruct!(::Val{2},
        state::AbstractVecOrMat{T},
        g::Val{$(QuoteNode(G))},
        locs::NTuple{N3,Int},
        control_locs::NTuple{N1,Int},
        control_bits::NTuple{N2,Int},
        theta::Basic,
    ) where {T,N1,N2,N3}
        m = parametric_mat(T, g, theta)
        instruct!(Val(2), state, m, locs, control_locs, control_bits)
    end

    # forward single gates
    @eval function YaoArrayRegister.instruct!(::Val{2},
        state::AbstractVecOrMat,
        g::Val{$(QuoteNode(G))},
        locs::NTuple{N1,Int},
        theta::Basic,
    ) where {N1}
        instruct!(Val(2), state, g, locs, (), (), theta)
    end

    @eval function YaoArrayRegister.instruct!(::Val{2},
        state::AbstractVecOrMat,
        g::Val{$(QuoteNode(G))},
        locs::Tuple{Int},
        theta::Basic,
    )
        instruct!(Val(2), state, g, locs, (), (), theta)
    end
end

@eval function YaoArrayRegister.instruct!(::Val{2},
    state::AbstractVecOrMat,
    g::Val{:PSWAP},
    locs::Tuple{Int,Int},
    theta::Basic,
)
    instruct!(Val(2), state, g, locs, (), (), theta)
end

using Test, YaoSym
using SymEngine
using YaoBlocks, LuxurySparse

@testset "apply" begin
    @vars θ γ η
    reg2 = rand_state(4)
    reg1 = ArrayReg(Basic.(state(reg2)))
    for G in [X, ConstGate.T, H]
        g = control(4, 3, 2 => G)
        @test copy(reg1) |> g ≈ copy(reg2) |> g
        # print reg2 errors
    end

    reg2 = arrayreg(bit"0011")
    reg1 = ArrayReg(Basic.(state(reg2)))
    for GC in [Rx, Ry, Rz, shift, phase, θ -> rot(SWAP, θ)]
        G = GC(θ)
        locs = nqubits(G) == 1 ? 2 : (3, 1)
        g1 = put(4, locs => GC(θ))
        g2 = put(4, locs => GC(π / 2))
        regs = state(copy(reg1) |> g1)
        res = subs.(regs, θ, Basic(π) / 2)
        @test res ≈ state(copy(reg2) |> g2)
    end

    CRk(::Type{T}, i::Int, j::Int, k::Int) where {T} = control([i], j => shift(2 * T(π) / (1 << k)))
    CRot(::Type{T}, n::Int, i::Int) where {T} =
        chain(n, i == j ? put(i => H) : CRk(T, j, i, j - i + 1) for j in i:n)
    qft(::Type{T}, n::Int) where {T} = chain(n, CRot(T, n, i) for i in 1:n)
    res = ket"11" |> qft(Basic, 2)
    l1 = length(string(res.state.nzval[2]))
    res.state.nzval .= simplify_expi.(res.state.nzval)
    @test length(string(res.state.nzval[2])) < l1
    @test res ≈ arrayreg(bit"11") |> qft(Float64, 2)
end

@testset "apply rot SWAP" begin
    @vars θ
    res = ket"01"
    # res  |> rot(SWAP, θ)
    @test_broken [ComplexF64(subs(si, θ => 0.5)) for si in res.state] ≈ (product_state(bit"01") |> rot(SWAP, 0.5)).state
end

function Base.iszero(x::Basic)
    isempty(free_symbols(x)) && iszero(N(x))
end

SymEngine.free_symbols(syms::Union{Real,Complex}) = Basic[]
SymEngine.free_symbols(syms::AbstractArray{T}) where {T<:Union{Real,Complex}} = Basic[]
SymEngine.free_symbols(syms::AbstractArray{T}) where {T<:Union{Basic,SymEngine.BasicType}} =
    SymEngine.free_symbols(Matrix(syms))
function rand_assign(syms...)
    fs = union(free_symbols.(syms)...)
    Dict(zip(fs, randn(length(fs))))
end

function _basic_approx(x, y; atol = 1e-8)
    diff = x - y
    assign = rand_assign(x, y)
    length(assign) > 0 && (diff = subs.(diff, Ref.((assign...,))...))
    nres = ComplexF64.(diff)
    all(isapprox.(nres, 0; atol = atol))
end

Base.:≈(x::AbstractArray{<:Basic}, y::AbstractArray; atol = 1e-8) = _basic_approx(x, y, atol = atol)
Base.:≈(x::AbstractArray, y::AbstractArray{<:Basic}; atol = 1e-8) = _basic_approx(x, y, atol = atol)
Base.:≈(x::AbstractArray{<:Basic}, y::AbstractArray{<:Basic}; atol = 1e-8) =
    _basic_approx(x, y, atol = atol)
function Base.Complex{T}(a::Basic) where {T}
    a = SymEngine.evalf(a)
    T(real(a)) + im * T(imag(a))
end

# simplification rules
function simplify_expi(expr::Basic)
    subs(
        expr,
        exp(im * Basic(π) / 2) => Basic(im),
        exp(im * Basic(π)) => -1,
        exp(im * Basic(π) * 3 / 2) => -Basic(im),
    )
end

Broadcast.broadcasted(
    ::Broadcast.AbstractArrayStyle{2},
    ::typeof(_pretty_basic),
    a::PermMatrix,
) = PermMatrix(a.perm, _pretty_basic.(a.vals))

Broadcast.broadcasted(
    ::LinearAlgebra.StructuredMatrixStyle{Diagonal},
    ::typeof(_pretty_basic),
    a::IMatrix,
) = IMatrix{Basic}(size(a, 1))

using Test, YaoSym, YaoArrayRegister
using SymEngine

@testset "constructors" begin
    @test ket"011" isa SymReg
    @test (ket"011")' isa AdjointSymReg
end

@testset "conversion" begin
    r = zero_state(3)
    sr = SymReg(r)

    for i in eachindex(r.state)
        @test r.state[i] ≈ N(sr.state[i])
    end
end

using Yao, Yao.EasyBuild, Test

@vars α β γ
c = chain(put(3, 2 => Rx(α)), control(3, 2, 1 => Ry(β)), put(3, (1, 2) => rot(kron(X, X), γ)))
h = heisenberg(3);
es = expect(h, zero_state(Basic, 3) => c)
gs = expect'(h, zero_state(Basic, 3) => c).second
assign = Dict(α => 0.5, β => 0.7, γ => 0.8)

cn = subs(Float64, c, assign...)
en = expect(h, zero_state(3) => cn)
gn = expect'(h, zero_state(3) => cn).second
es_ = subs(es, assign...)
gs_ = map(x -> subs(x, assign...), gs)
@test ComplexF64.(gs_) ≈ gn
@test ComplexF64(es_) ≈ en

YaoArrayRegister._warn_type(raw::AbstractMatrix{Basic}) = nothing

const SymReg{D,MT} = AbstractArrayReg{D,Basic,MT} where {MT<:AbstractMatrix{Basic}}
const AdjointSymReg{D,MT} = AdjointArrayReg{D,Basic,MT}
const SymRegOrAdjointSymReg{D,MT} = Union{SymReg{D,MT},AdjointSymReg{D,MT}}

function SymReg{D,MT}(r::ArrayReg{D,<:Number}) where {D,MT<:AbstractMatrix{Basic}}
    return ArrayReg{D}(MT(Basic.(r.state)))
end
function SymReg{D,MT}(r::BatchedArrayReg{D,<:Number}) where {D,MT<:AbstractMatrix{Basic}}
    return BatchedArrayReg{D}(MT(Basic.(r.state)), r.nbatch)
end

function SymReg(r::AbstractArrayReg{D,<:Number}) where {D}
    smat = SparseMatrixCSC(Basic.(_pretty_basic.(r.state)))
    return arrayreg(SparseMatrixCSC(smat); nbatch=nbatch(r), nlevel=D)
end

_pretty_basic(x) = Basic(x)
_pretty_basic(x::Real) = isinteger(x) ? Basic(Int(x)) : Basic(x)
function _pretty_basic(x::Complex)
    if isreal(x)
        return _pretty_basic(real(x))
    elseif iszero(real(x))
        return Basic(im)*_pretty_basic(imag(x))
    else
        return _pretty_basic(real(x)) + Basic(im) * _pretty_basic(imag(x))
    end
end

function ket_m(s::AbstractString)
    v, N = parse_str(s)
    st = spzeros(Basic, 1 << N, 1)
    st[v+1] = 1
    return ArrayReg(st)
end


const MAX_SYM_QUBITS = 10

for REG in [:(ArrayReg{D, Basic} where D), :(BatchedArrayReg{D, Basic} where D), :(AdjointArrayReg{D,Basic} where D)]
    @eval function Base.show(io::IO, r::$REG)
        if nqudits(r) < MAX_SYM_QUBITS
            print_sym_state(io, r)
        else
            summary(io, r)
            print(io, "\n    active qudits: ", nactive(r), "/", nqudits(r))
        end
    end
end

Base.:(*)(x::SymReg{D,MT}, y::SymReg{D,MT}) where {D,MT} = arrayreg(kron(state(x), state(y)); nlevel=D, nbatch=nbatch(x))
Base.:(*)(x::AdjointSymReg{D,MT}, y::AdjointSymReg{D,MT}) where {D,MT} =
    adjoint(parent(x) * parent(y))

Base.:(^)(x::SymReg{D,MT}, n::Int) where {D,MT} = arrayreg(kron(state(x) for _ in 1:n); nlevel=D, nbatch=nbatch(x))
Base.:(^)(x::AdjointSymReg{D,MT}, n::Int) where {D,MT} = adjoint(parent(x)^n)

SymEngine.expand(x::SymReg{D}) where {D} = arrayreg(expand.(state(x)); nlevel=D, nbatch=nbatch(x))

"""
    szero_state(n; nbatch=1)

Create a symbolic zero state, same as `ket"000"`, but allows you use an integer.
"""
szero_state(args...; kwargs...) = zero_state(Basic, args...; kwargs...)

using YaoSym, YaoBlocks, YaoArrayRegister, SymEngine
using YaoSym: simplify_expi, BasicType
using SymEngine
using Test

@testset "imag and conj" begin
    @vars a b c d x
    @test imag(Basic(2 + im * a)) == a
    @test imag(Basic((2 + im) * (im * a + 1))) == 2 * a + 1
    @test real(sin(a)) == sin(a)
    @test imag(sin(a)) == 0
    @test imag(x^2) == 0
    @test real(x^2) == x^2
    @test real(exp(im * a)) == cos(a)
    @test imag(exp(im * a)) == sin(a)
    @test abs(exp(im * a)) == 1
    @test BasicType(imag(cos(im * a + b))) isa BasicType{Val{:FunctionSymbol}}
    @test BasicType(real((im*c + d)^(im * a + b))) isa BasicType{Val{:FunctionSymbol}}
    @test BasicType(real(sin(im * a + b))) isa BasicType{Val{:FunctionSymbol}}
end

@testset "mat" begin
    @vars θ γ η
    for G in [X, Y, Z, ConstGate.T, H, ConstGate.S, ConstGate.Sdag, ConstGate.Tdag, ConstGate.T, I2, (0.5+0.5im)*X]
        B = mat(Basic, G)
        @test eltype(B) === Basic
        @test Matrix(B) ≈ Matrix(mat(G))
        @test Matrix(mat(Basic, control(4, 3, 2 => G))) ≈ Matrix(control(4, 3, 2 => G))
    end

    for GC in [Rx, shift, phase]
        G = GC(θ)
        m = mat(Basic, G)
        m = subs.(m, θ, 0.5)
        @test Matrix(mat(GC(0.5))) ≈ Matrix(m)
        @test subs.(Matrix(mat(Basic, put(4, 2 => G))), θ, 0.5) ≈ Matrix(put(4, 2 => GC(0.5)))
    end

    G = Rz(θ) * Rx(γ) * Rz(θ)
    m = mat(Basic, G)
    @test mat(G) == m
    @test_throws ArgumentError mat(Float64, G)
    m = subs.(m, Ref((θ, Basic(π) / 2)), Ref((γ, Basic(π) / 6)))
    @test Matrix(mat(Rz(π / 2) * Rx(π / 6) * Rz(π / 2))) ≈ Matrix(m)

    A = randn(ComplexF64, 4, 4)
    mb = matblock(Basic.(A))
    @test Matrix(mb) ≈ A

    @test pswap(4, 2, 1, θ) == pswap(2, 1, θ)(4)
    @test pswap(4, 2, 1, θ) isa PSwap{Basic}
end

@testset "sub" begin
    @vars θ ϕ
    @test subs(Float64, Rx(θ), θ => 0.5) == Rx(0.5)
    @test subs(Float64, shift(θ), θ => 0.5) == shift(0.5)
    @test subs(Float64, phase(θ), θ => 0.5) == phase(0.5)
    @test subs(
        Float64,
        chain(control(2, 1, 2 => shift(θ)), put(2, 1 => chain(Rx(θ), kron(Rx(θ))))),
        θ => 0.5,
    ) == chain(control(2, 1, 2 => shift(0.5)), put(2, 1 => chain(Rx(0.5), kron(Rx(0.5)))))
    @test subs(Float64, time_evolve(X, θ), θ => 0.5) == time_evolve(X, 0.5)
    @test subs(Rx(θ), θ => ϕ) == Rx(ϕ)
end

@testset "Sym Engine Conj" begin
    @vars a b
    @test cos(exp(a + im * b))' == cos(exp(a - im * b))
    @test cos(exp(a + im * b))' == cos(exp(a - im * b))
    @test mat(Rx(a)) == [
        cos(a / 2) -im*sin(a / 2)
        -im*sin(a / 2) cos(a / 2)
    ]
    @test mat(Rx(a)') == [
        cos(a / 2) im*sin(a / 2)
        im*sin(a / 2) cos(a / 2)
    ]
end

@testset "expect" begin
    @vars a b
    reg = ket"111" |> control(3, 1, 2 => Rx(a))
    op = put(3, 2 => Z)
    reg2 = arrayreg(bit"111") |> control(3, 1, 2 => Rx(0.5))
    ex = expect(op, reg)
    ex = subs(ex, a => 0.5)
    @test ComplexF64(ex) ≈ expect(op, reg2)
end

@testset "grad" begin
    @vars a b
    reg = arrayreg(Basic, bit"111") => control(3, 1, 2 => Rx(a))
    op = put(3, 2 => Z)
    reg2 = arrayreg(bit"111") => control(3, 1, 2 => Rx(0.5))
    ex = expect'(op, reg)[2]
    ex = subs(ex[], a => 0.5)
    @test ComplexF64(ex) ≈ expect'(op, reg2)[2][]
end

@testset "grad" begin
    @vars a b
    reg = arrayreg(Basic, bit"000") => put(3, 2 => Rx(a))
    op = put(3, 2 => Z)
    reg2 = arrayreg(bit"000") => put(3, 2 => Rx(0.9))
    ex = expect(op, reg)
    ex = subs(ex[], a => 0.9)
    @test ComplexF64(ex) ≈ expect(op, reg2)
    ex = expect'(op, reg)[2]
    ex = subs(ex[], a => 0.9)
    @test ComplexF64(ex) ≈ expect'(op, reg2)[2][]
end

function test_check_dumpload(gate::AbstractBlock{N}) where {N}
    gate2 = eval(YaoBlocks.parse_ex(YaoBlocks.dump_gate(gate), N))
    gate2 == gate || mat(gate2) ≈ mat(gate)
end

@testset "dumpload" begin
    # basic types
    @vars θ
    @test test_check_dumpload(phase(θ))
    @test test_check_dumpload(shift(θ))
    @test test_check_dumpload(time_evolve(X, θ))
    @test test_check_dumpload(rot(X, θ))
end

@testset "angle" begin
    @vars x
    @test_broken Float64(angle(Basic(1 + im))) ≈ π / 4
    @test angle(x) == Basic(0)
    @test BasicType(angle((1+x)^x)) isa BasicType{Val{:FunctionSymbol}}
    @test angle(Basic(1)) == Basic(0)
    @test angle(exp(Basic(1))) == Basic(0)
end

op_types = [:Mul, :Add, :Pow]
const BiVarOp = Union{[SymEngine.BasicType{Val{i}} for i in op_types]...}

simag = SymFunction("Im")
sreal = SymFunction("Re")
sangle = SymFunction("angle")

Base.promote_rule(::Type{Bool}, ::Type{Basic}) = Basic
# NOTE: need to annotate the output because otherwise it is type unstable!
Base.abs(x::Basic)::Basic = Basic(abs(SymEngine.BasicType(x)))
function Base.abs(x::BasicType{Val{:Pow}})
    a, b = get_args(x.x)
    abs(a)^real(b) * exp(-angle(a) * imag(b))
end

Base.angle(x::Basic)::Basic = Basic(angle(SymEngine.BasicType(x)))
Base.angle(x::BasicType)::Basic = sangle(x.x)
Base.angle(::BasicType{Val{:Symbol}})::Basic = Basic(0)
Base.angle(::BasicType{Val{:Constant}})::Basic = Basic(0)
Base.angle(::SymEngine.BasicRealNumber)::Basic = Basic(0)

Base.conj(x::BiVarOp) = juliafunc(x)(conj.(get_args(x.x))...)
Base.conj(x::BasicTrigFunction) = juliafunc(x)(conj.(get_args(x.x)...)...)

Base.imag(::BasicType{Val{:Constant}}) = Basic(0)
Base.imag(::BasicType{Val{:Symbol}}) = Basic(0)
function Base.imag(x::BasicType{Val{:Add}})
    args = get_args(x.x)
    mapreduce(imag, +, args)
end
function Base.imag(x::BasicType{Val{:Mul}})
    args = (get_args(x.x)...,)
    get_mul_imag(args)
end
function Base.imag(x::BasicType{Val{:Pow}})
    a, b = get_args(x.x)
    if imag(a) == 0 && imag(b) == 0
        return Basic(0)
    else
        if imag(a) == 0
            return a^real(b) * sin(log(a) * imag(b))
        else
            return simag(x.x)
        end
    end
end
function Base.imag(x::BasicTrigFunction)
    a, = get_args(x.x)
    if imag(a) == 0
        return Basic(0)
    else
        return simag(x.x)
    end
end
function get_mul_imag(args::NTuple{N,Any}) where {N}
    imag(args[1]) * get_mul_real(args[2:end]) + real(args[1]) * get_mul_imag(args[2:end])
end
get_mul_imag(args::Tuple{Basic}) = imag(args[1])

function Base.real(x::BasicType{Val{:Add}})
    args = get_args(x.x)
    mapreduce(real, +, args)
end
function Base.real(x::BasicType{Val{:Pow}})
    a, b = get_args(x.x)
    if imag(a) == 0 && imag(b) == 0
        return x.x
    else
        if imag(a) == 0
            return a^real(b) * cos(log(a) * imag(b))
        else
            return sreal(x.x)
        end
    end
end
function Base.real(x::BasicType{Val{:Mul}})
    args = (get_args(x.x)...,)
    get_mul_real(args)
end
function Base.real(x::BasicTrigFunction)
    a, = get_args(x.x)
    if imag(a) == 0
        return x.x
    else
        return sreal(x.x)
    end
end
function get_mul_real(args::NTuple{N,Any}) where {N}
    real(args[1]) * get_mul_real(args[2:end]) - imag(args[1]) * get_mul_imag(args[2:end])
end
get_mul_real(args::Tuple{Basic}) = real(args[1])

@generated function juliafunc(x::BasicType{Val{T}}) where {T}
    SymEngine.map_fn(T, SymEngine.fn_map)
end

const SymReal = Union{Basic,SymEngine.BasicRealNumber}
YaoBlocks.RotationGate(block::GT, theta::T) where {D,T<:SymReal,GT<:AbstractBlock{D}} =
    RotationGate{D,T,GT}(block, theta)

YaoBlocks.phase(θ::SymReal) = PhaseGate(θ)
YaoBlocks.shift(θ::SymReal) = ShiftGate(θ)

YaoBlocks.mat(::Type{Basic}, gate::GT) where GT<:ConstantGate = _pretty_basic.(mat(gate))
YaoBlocks.mat(::Type{Basic}, gate::ConstGate.TGate) = Diagonal(Basic[1, exp(Basic(im)*Basic(π)/4)])
YaoBlocks.mat(::Type{Basic}, gate::ConstGate.TdagGate) = Diagonal(Basic[1, exp(-Basic(im)*Basic(π)/4)])
YaoArrayRegister._hadamard_matrix(::Type{Basic}) = 1 / sqrt(Basic(2)) * Basic[1 1; 1 -1]
YaoBlocks.mat(::Type{Basic}, ::HGate) = YaoArrayRegister._hadamard_matrix(Basic)
YaoBlocks.mat(::Type{Basic}, gate::ShiftGate) = Diagonal([1, exp(im * gate.theta)])
YaoBlocks.mat(::Type{Basic}, gate::PhaseGate) = exp(im * gate.theta) * IMatrix(2)
function YaoBlocks.mat(::Type{Basic}, R::RotationGate{D}) where {D}
    I = IMatrix(D^nqudits(R))
    return I * cos(R.theta / 2) - im * sin(R.theta / 2) * mat(Basic, R.block)
end
for GT in [:XGate, :YGate, :ZGate]
    @eval YaoBlocks.mat(::Type{Basic}, R::RotationGate{D,T,<:$GT}) where {D,T} =
        invoke(mat, Tuple{Type{Basic},RotationGate}, Basic, R)
end

for T in [:(RotationGate{D,<:SymReal} where D), :(PhaseGate{<:SymReal}), :(ShiftGate{<:SymReal})]
    @eval YaoBlocks.mat(gate::$T) = mat(Basic, gate)
end

YaoBlocks.PSwap(n::Int, locs::Tuple{Int,Int}, θ::SymReal) =
    YaoBlocks.PutBlock(n, rot(ConstGate.SWAPGate(), θ), locs)

YaoBlocks.pswap(n::Int, i::Int, j::Int, α::SymReal) = PSwap(n, (i, j), α)
YaoBlocks.pswap(i::Int, j::Int, α::SymReal) = n -> pswap(n, i, j, α)

SymEngine.subs(c::AbstractBlock, args...; kwargs...) = subs(Basic, c, args...; kwargs...)
function SymEngine.subs(::Type{T}, c::AbstractBlock, args...; kwargs...) where {T}
    c = setiparams(c, map(x -> T(subs(x, args...; kwargs...)), getiparams(c))...)
    chsubblocks(c, [subs(T, blk, args..., kwargs...) for blk in subblocks(c)])
end

# dumpload
YaoBlocks.tokenize_param(param::Basic) = QuoteNode(Symbol(param))
YaoBlocks.parse_param(x::QuoteNode) = :(Basic($x))

using Test
using YaoSym, YaoArrayRegister, YaoBlocks, SymEngine

@test ket"111" + 2 * ket"111" == 3 * ket"111"
@test bra"111" * ket"111" == 1
@test (bra"111" + bra"101") * ket"111" == 1

@test ket"111"^2 == ket"111111"

# TODO: remove this!
@test ket"101" * ket"111" == ket"101111"

@test bra"110"^2 == bra"110110"

# TODO: remove this!
@test bra"110" * bra"111" == bra"110111" == bra"110_111"

# printing does not error
@test print(ket"001") === nothing
@test print(bra"001") === nothing
@test print(bra"111" + bra"101") === nothing

function parse_str(s::String)
    v = 0
    k = 1
    for each in reverse(filter(x -> x != '_', s))
        if each == '1'
            v += 1 << (k - 1)
            k += 1
        elseif each == '0'
            k += 1
        elseif each == '_'
            continue
        else
            error("expect 0 or 1, got $each at $k-th bit")
        end
    end
    return v, k - 1
end

function ket_m(s)
    error(
        "Please install SymEngine and type using SymEngine explicitly to use symbolic functionality of Yao",
    )
end

function bra_m(s)
    adjoint(ket_m(s))
end

"""
    @ket_str

Create a ket register. See also [`@bra_str`](@ref).

### Examples

a symbolic quantum state can be created simply by

```jldoctest; setup=:(using Yao)
julia> ket"110" + 2ket"111"
|110⟩ + 2.0|111⟩
```

qubits can be partially actived by [`focus!`](@ref)

```jldoctest; setup=:(using Yao)
julia> ket"100" + ket"111" |> focus!(1:2)
|100⟩ + |111⟩
```

"""
macro ket_str(s)
    ket_m(s)
end

"""
    @bra_str

Create a bra register. See also [`@ket_str`](@ref).

### Examples

Similar to `@ket_str` literal, a symbolic quantum state can be created
by

```jldoctest; setup=:(using Yao)
julia> bra"111" + 2bra"101"
2.0⟨101| + ⟨111|

julia> bra"111" * (ket"101" + ket"111")
1
```
"""
macro bra_str(s)
    bra_m(s)
end

function print_braket(f, io::IO, r)
    print(io, "|")
    f()
    print(io, "⟩")
end

function print_braket(f, io::IO, r::AdjointArrayReg)
    print(io, "⟨")
    f()
    print(io, "|")
end

function print_basis(io, active::Int, remain::Int, r)
    print_braket(io, r) do
        printstyled(io, string(remain, base = 2, pad = nremain(r)), color = :light_black)
        print(io, string(active, base = 2, pad = nactive(r)))
    end
end

function print_amp(io::IO, x)
    if !isone(x)
        if isempty(free_symbols(x))
            print(io, round(N(x); digits = 2))
        else
            print(io, x)
        end
    end
end

function print_sym_state(io::IO, r::ArrayReg)
    st = state(r)
    m, n = size(st)
    isfirst_nonzero = true
    amp = st[1, 1]
    if !iszero(amp)
        print_amp(io, amp)
        print_basis(io, 0, 0, r)
        isfirst_nonzero = false
    end

    for j in 1:n, i in 1:m
        i == 1 && j == 1 && continue
        amp = st[i, j]
        if iszero(amp)
            continue
        end

        isfirst_nonzero || print(io, " + ")
        print_amp(io, amp)
        print_basis(io, i - 1, j - 1, r)
        isfirst_nonzero = false
    end
end

function print_sym_state(io::IO, r::AdjointRegister{D,<:ArrayReg{D}}) where D
    st = state(r)
    m, n = size(st)
    isfirst_nonzero = true
    amp = st[1, 1]
    if !iszero(amp)
        print_amp(io, amp)
        print_basis(io, 0, 0, r)
        isfirst_nonzero = false
    end

    for j in 1:n, i in 1:m
        i == 1 && j == 1 && continue
        amp = st[i, j]
        if iszero(amp)
            continue
        end

        isfirst_nonzero || print(io, " + ")
        print_amp(io, amp)
        print_basis(io, j - 1, i - 1, r)
        isfirst_nonzero = false
    end
end

# TODO: need a more extensible implementation
# Base.:(*)(x::SymReg{B, MT}, y::SymReg{B, MT}) where {B, MT} = SymReg{B, MT}(kron(state(x), state(y)))
# Base.:(^)(x::SymReg{B, MT}, n::Int) where {B, MT} = SymReg{B, MT}(kron(state(x) for _ in 1:n))

# Base.:(*)(x::AdjointSymReg{B, MT}, y::AdjointSymReg{B, MT}) where {B, MT} = adjoint(parent(x) * parent(y))
# Base.:(^)(x::AdjointSymReg{B, MT}, n::Int) where {B, MT} = adjoint(parent(x)^n)

module YaoSym

using SparseArrays, LuxurySparse, LinearAlgebra
using BitBasis, YaoArrayRegister, YaoBlocks
import YaoArrayRegister: parametric_mat
using SymEngine
using SymEngine: @vars, Basic, BasicType, BasicOp, BasicTrigFunction, BasicComplexNumber

# SymEngine APIs
export @vars, Basic, subs, expand, simplify_expi

# Symbolic registers
export @ket_str, @bra_str
export SymReg, AdjointSymReg, SymRegOrAdjointSymReg
export szero_state

include("register.jl")
include("symengine/symengine.jl")

end # module
